Index: c/src/lib/libbsp/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/ChangeLog,v
retrieving revision 1.63
diff -p -u -u -r1.63 ChangeLog
--- c/src/lib/libbsp/ChangeLog	11 Dec 2008 10:27:20 -0000	1.63
+++ c/src/lib/libbsp/ChangeLog	24 Apr 2009 07:09:15 -0000
@@ -1,3 +1,8 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* Makefile.am: Add bspinit.c, a common Init task that manages
+	command line arguments from a BSP.
+
 2008-12-11	Ralf Corsépius <ralf.corsepius@rtems.org>
 
 	* shared/clockdrv_shell.c: Turn warning into error.
Index: c/src/lib/libbsp/Makefile.am
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/Makefile.am,v
retrieving revision 1.25
diff -p -u -u -r1.25 Makefile.am
--- c/src/lib/libbsp/Makefile.am	26 Sep 2008 05:40:00 -0000	1.25
+++ c/src/lib/libbsp/Makefile.am	24 Apr 2009 07:09:15 -0000
@@ -10,10 +10,10 @@ DIST_SUBDIRS = @libbsp_cpu_subdir@
 EXTRA_DIST = MERGE.PROCEDURE bsp.am
 
 # shared
-EXTRA_DIST += shared/bootcard.c shared/bspclean.c shared/bsplibc.c \
-    shared/bsppost.c shared/console-polled.c shared/console.c \
-    shared/gnatinstallhandler.c shared/sbrk.c shared/tod.c \
-    shared/tod.h
+EXTRA_DIST += shared/bootcard.c shared/bspclean.c shared/bspinit.c \
+    shared/bsplibc.c shared/bsppost.c shared/console-polled.c \
+    shared/console.c shared/gnatinstallhandler.c shared/sbrk.c \
+    shared/tod.c shared/tod.h
 EXTRA_DIST += shared/vmeUniverse/vmeUniverse.c \
     shared/vmeUniverse/vmeUniverse.h \
     shared/vmeUniverse/vmeUniverseDMA.h \
Index: c/src/lib/libbsp/arm/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/arm/ChangeLog,v
retrieving revision 1.67
diff -p -u -u -r1.67 ChangeLog
--- c/src/lib/libbsp/arm/ChangeLog	12 Mar 2009 14:18:11 -0000	1.67
+++ c/src/lib/libbsp/arm/ChangeLog	24 Apr 2009 07:09:15 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* shared/start/start.S: Update for boot_card command line change.
+
 2009-03-12	Joel Sherrill <joel.sherrill@OARcorp.com>
 
 	PR 1385/cpukit
Index: c/src/lib/libbsp/arm/csb336/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/arm/csb336/ChangeLog,v
retrieving revision 1.53
diff -p -u -u -r1.53 ChangeLog
--- c/src/lib/libbsp/arm/csb336/ChangeLog	6 Jan 2009 16:26:21 -0000	1.53
+++ c/src/lib/libbsp/arm/csb336/ChangeLog	24 Apr 2009 07:09:15 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* start/start.S: Update for boot_card command line change.
+
 2009-01-06	Joel Sherrill <joel.sherrill@OARcorp.com>
 
 	PR 1350/bsps
Index: c/src/lib/libbsp/arm/csb336/start/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/arm/csb336/start/start.S,v
retrieving revision 1.3
diff -p -u -u -r1.3 start.S
--- c/src/lib/libbsp/arm/csb336/start/start.S	12 Mar 2007 11:18:44 -0000	1.3
+++ c/src/lib/libbsp/arm/csb336/start/start.S	24 Apr 2009 07:09:15 -0000
@@ -12,7 +12,11 @@
  * $Id: start.S,v 1.3 2007/03/12 11:18:44 joel Exp $
  */
 
-                
+#warning Call to boot_card has changed and needs checking.
+#warning The call is "void boot_card(const char* cmdline);"
+#warning You need to pass a NULL.
+#warning Please check and remove these warnings.
+         
 /* Some standard definitions...*/
 .equ PSR_MODE_USR,       0x10
 .equ PSR_MODE_FIQ,       0x11
Index: c/src/lib/libbsp/arm/csb337/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/arm/csb337/ChangeLog,v
retrieving revision 1.46
diff -p -u -u -r1.46 ChangeLog
--- c/src/lib/libbsp/arm/csb337/ChangeLog	5 Dec 2008 13:37:41 -0000	1.46
+++ c/src/lib/libbsp/arm/csb337/ChangeLog	24 Apr 2009 07:09:15 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* start/start.S: Update for boot_card command line change.
+
 2008-12-05	Ralf Corsépius <ralf.corsepius@rtems.org>
 
 	* bsp_specs: Remove -Qy from *link.
Index: c/src/lib/libbsp/arm/csb337/start/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/arm/csb337/start/start.S,v
retrieving revision 1.2
diff -p -u -u -r1.2 start.S
--- c/src/lib/libbsp/arm/csb337/start/start.S	12 Mar 2007 11:18:47 -0000	1.2
+++ c/src/lib/libbsp/arm/csb337/start/start.S	24 Apr 2009 07:09:15 -0000
@@ -12,6 +12,10 @@
  *  $Id: start.S,v 1.2 2007/03/12 11:18:47 joel Exp $
 */
 
+#warning Call to boot_card has changed and needs checking.
+#warning The call is "void boot_card(const char* cmdline);"
+#warning You need to pass a NULL.
+#warning Please check and remove these warnings.
                 
 /* Some standard definitions...*/
 .equ PSR_MODE_USR,       0x10
Index: c/src/lib/libbsp/arm/edb7312/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/arm/edb7312/ChangeLog,v
retrieving revision 1.96
diff -p -u -u -r1.96 ChangeLog
--- c/src/lib/libbsp/arm/edb7312/ChangeLog	5 Dec 2008 13:37:43 -0000	1.96
+++ c/src/lib/libbsp/arm/edb7312/ChangeLog	24 Apr 2009 07:09:15 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* start/start.S: Update for boot_card command line change.
+
 2008-12-05	Ralf Corsépius <ralf.corsepius@rtems.org>
 
 	* bsp_specs: Remove -Qy from *link.
Index: c/src/lib/libbsp/arm/edb7312/start/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/arm/edb7312/start/start.S,v
retrieving revision 1.6
diff -p -u -u -r1.6 start.S
--- c/src/lib/libbsp/arm/edb7312/start/start.S	21 Apr 2004 16:01:32 -0000	1.6
+++ c/src/lib/libbsp/arm/edb7312/start/start.S	24 Apr 2009 07:09:15 -0000
@@ -14,6 +14,11 @@
  *  $Id: start.S,v 1.6 2004/04/21 16:01:32 ralf Exp $
 */
 
+#warning Call to boot_card has changed and needs checking.
+#warning The call is "void boot_card(const char* cmdline);"
+#warning You need to pass a NULL.
+#warning Please check and remove these warnings.
+	
 /* Some standard definitions...*/
 
 .equ Mode_USR,        	     0x10
Index: c/src/lib/libbsp/arm/gba/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/arm/gba/ChangeLog,v
retrieving revision 1.52
diff -p -u -u -r1.52 ChangeLog
--- c/src/lib/libbsp/arm/gba/ChangeLog	12 Mar 2009 14:18:07 -0000	1.52
+++ c/src/lib/libbsp/arm/gba/ChangeLog	24 Apr 2009 07:09:15 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* start/start.S: Update for boot_card command line change.
+
 2009-03-12	Joel Sherrill <joel.sherrill@OARcorp.com>
 
 	PR 1385/cpukit
Index: c/src/lib/libbsp/arm/gba/start/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/arm/gba/start/start.S,v
retrieving revision 1.1
diff -p -u -u -r1.1 start.S
--- c/src/lib/libbsp/arm/gba/start/start.S	6 Jul 2005 18:46:04 -0000	1.1
+++ c/src/lib/libbsp/arm/gba/start/start.S	24 Apr 2009 07:09:15 -0000
@@ -50,6 +50,11 @@
  * INABILITY TO USE THIS CODE.
  *****************************************************************************/
 
+#warning Call to boot_card has changed and needs checking.
+#warning The call is "void boot_card(const char* cmdline);"
+#warning You need to pass a NULL.
+#warning Please check and remove these warnings.
+	
 #define __asm__
 #include <rtems/asm.h>
 #include <asm_macros.h>
Index: c/src/lib/libbsp/arm/gp32/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/arm/gp32/ChangeLog,v
retrieving revision 1.46
diff -p -u -u -r1.46 ChangeLog
--- c/src/lib/libbsp/arm/gp32/ChangeLog	4 Dec 2008 20:30:15 -0000	1.46
+++ c/src/lib/libbsp/arm/gp32/ChangeLog	24 Apr 2009 07:09:15 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* start/start.S: Update for boot_card command line change.
+
 2008-12-04	Joel Sherrill <joel.sherrill@oarcorp.com>
 
 	* bsp_specs: Move -e start from *link to *startfile to avoid warning
Index: c/src/lib/libbsp/arm/gp32/start/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/arm/gp32/start/start.S,v
retrieving revision 1.2
diff -p -u -u -r1.2 start.S
--- c/src/lib/libbsp/arm/gp32/start/start.S	12 Mar 2007 11:18:49 -0000	1.2
+++ c/src/lib/libbsp/arm/gp32/start/start.S	24 Apr 2009 07:09:15 -0000
@@ -11,7 +11,11 @@
  *  $Id: start.S,v 1.2 2007/03/12 11:18:49 joel Exp $
  */
 
-                
+#warning Call to boot_card has changed and needs checking.
+#warning The call is "void boot_card(const char* cmdline);"
+#warning You need to pass a NULL.
+#warning Please check and remove these warnings.
+        
 /* Some standard definitions...*/
 .equ PSR_MODE_USR,       0x10
 .equ PSR_MODE_FIQ,       0x11
Index: c/src/lib/libbsp/arm/nds/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/arm/nds/ChangeLog,v
retrieving revision 1.31
diff -p -u -u -r1.31 ChangeLog
--- c/src/lib/libbsp/arm/nds/ChangeLog	4 Feb 2009 15:42:03 -0000	1.31
+++ c/src/lib/libbsp/arm/nds/ChangeLog	24 Apr 2009 07:09:15 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* start/start.S: Update for boot_card command line change.
+
 2009-02-04	Ralf Corsépius <ralf.corsepius@rtems.org>
 
 	* Makefile.am: Add -D__BSD_VISIBLE to wifi_rel_CPPFLAGS.
Index: c/src/lib/libbsp/arm/nds/start/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/arm/nds/start/start.S,v
retrieving revision 1.1
diff -p -u -u -r1.1 start.S
--- c/src/lib/libbsp/arm/nds/start/start.S	16 Apr 2008 18:37:33 -0000	1.1
+++ c/src/lib/libbsp/arm/nds/start/start.S	24 Apr 2009 07:09:15 -0000
@@ -1,3 +1,8 @@
+#warning Call to boot_card has changed and needs checking.
+#warning The call is "void boot_card(const char* cmdline);"
+#warning You need to pass a NULL.
+#warning Please check and remove these warnings.
+
 @---------------------------------------------------------------------------------
 @ DS processor selection
 @---------------------------------------------------------------------------------
@@ -201,8 +206,7 @@ _start:
 	ldr	r3, =initSystem
 	blx	r3			@ jump to user code
 
-	mov	r1, #0		@ argv
-	mov	r0, #0		@ argc
+	mov	r0, #0		@ command line
 
 
 	ldr	r3, =boot_card
Index: c/src/lib/libbsp/arm/rtl22xx/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/arm/rtl22xx/ChangeLog,v
retrieving revision 1.39
diff -p -u -u -r1.39 ChangeLog
--- c/src/lib/libbsp/arm/rtl22xx/ChangeLog	2 Mar 2009 17:03:10 -0000	1.39
+++ c/src/lib/libbsp/arm/rtl22xx/ChangeLog	24 Apr 2009 07:09:15 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* start/start.S: Update for boot_card command line change.
+
 2009-03-02	Ray Xu <rayx.cn@gmail.com>
 
 	PR 1380/bsps
Index: c/src/lib/libbsp/arm/rtl22xx/start/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/arm/rtl22xx/start/start.S,v
retrieving revision 1.4
diff -p -u -u -r1.4 start.S
--- c/src/lib/libbsp/arm/rtl22xx/start/start.S	6 Nov 2007 22:50:42 -0000	1.4
+++ c/src/lib/libbsp/arm/rtl22xx/start/start.S	24 Apr 2009 07:09:15 -0000
@@ -12,6 +12,11 @@
  *  $Id: start.S,v 1.4 2007/11/06 22:50:42 joel Exp $
 */
 
+#warning Call to boot_card has changed and needs checking.
+#warning The call is "void boot_card(const char* cmdline);"
+#warning You need to pass a NULL.
+#warning Please check and remove these warnings.
+	
 /* Some standard definitions...*/
 
 /* Some standard definitions...*/
Index: c/src/lib/libbsp/arm/shared/start/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/arm/shared/start/start.S,v
retrieving revision 1.2
diff -p -u -u -r1.2 start.S
--- c/src/lib/libbsp/arm/shared/start/start.S	27 Feb 2009 11:26:44 -0000	1.2
+++ c/src/lib/libbsp/arm/shared/start/start.S	24 Apr 2009 07:09:15 -0000
@@ -16,6 +16,11 @@
  * LICENSE in this distribution or at http://www.rtems.com/license/LICENSE.
  */
 
+#warning Call to boot_card has changed and needs checking.
+#warning The call is "void boot_card(const char* cmdline);"
+#warning You need to pass a NULL.
+#warning Please check and remove these warnings.
+	
 #include <bsp/linker-symbols.h>
 #include <bsp/start.h>
 
Index: c/src/lib/libbsp/avr/avrtest/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/avr/avrtest/ChangeLog,v
retrieving revision 1.2
diff -p -u -u -r1.2 ChangeLog
--- c/src/lib/libbsp/avr/avrtest/ChangeLog	4 Dec 2008 20:33:50 -0000	1.2
+++ c/src/lib/libbsp/avr/avrtest/ChangeLog	24 Apr 2009 07:09:15 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* start/start.S: Update for boot_card command line change.
+
 2008-12-04	Joel Sherrill <joel.sherrill@oarcorp.com>
 
 	* bsp_specs, start/start.S: Move -e start from *link to *startfile to
Index: c/src/lib/libbsp/avr/avrtest/start/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/avr/avrtest/start/start.S,v
retrieving revision 1.2
diff -p -u -u -r1.2 start.S
--- c/src/lib/libbsp/avr/avrtest/start/start.S	4 Dec 2008 20:33:50 -0000	1.2
+++ c/src/lib/libbsp/avr/avrtest/start/start.S	24 Apr 2009 07:09:15 -0000
@@ -1,3 +1,6 @@
+#warning Call to boot_card has changed and needs checking.
+#warning The call is "void boot_card(const char* cmdline);"
+#warning Please check and remove these warnings.
 
 #define SPL 0x3d
 #define SPH 0x3e
Index: c/src/lib/libbsp/bfin/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/bfin/ChangeLog,v
retrieving revision 1.16
diff -p -u -u -r1.16 ChangeLog
--- c/src/lib/libbsp/bfin/ChangeLog	25 Sep 2008 14:10:51 -0000	1.16
+++ c/src/lib/libbsp/bfin/ChangeLog	24 Apr 2009 07:09:15 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* shared/start/start.S: Update for boot_card command line change.
+
 2008-09-25	Joel Sherrill <joel.sherrill@oarcorp.com>
 
 	* shared/start/start.S: Add BFIN_ON_SKYEYE define to disable features
Index: c/src/lib/libbsp/bfin/bf537Stamp/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/bfin/bf537Stamp/ChangeLog,v
retrieving revision 1.14
diff -p -u -u -r1.14 ChangeLog
--- c/src/lib/libbsp/bfin/bf537Stamp/ChangeLog	4 Dec 2008 20:31:37 -0000	1.14
+++ c/src/lib/libbsp/bfin/bf537Stamp/ChangeLog	24 Apr 2009 07:09:15 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* start/start.S: Update for boot_card command line change.
+
 2008-12-04	Joel Sherrill <joel.sherrill@oarcorp.com>
 
 	* bsp_specs: Move -e start from *link to *startfile to avoid warning
Index: c/src/lib/libbsp/bfin/bf537Stamp/start/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/bfin/bf537Stamp/start/start.S,v
retrieving revision 1.1
diff -p -u -u -r1.1 start.S
--- c/src/lib/libbsp/bfin/bf537Stamp/start/start.S	15 Aug 2008 20:21:00 -0000	1.1
+++ c/src/lib/libbsp/bfin/bf537Stamp/start/start.S	24 Apr 2009 07:09:15 -0000
@@ -7,6 +7,10 @@
 #include <libcpu/cecRegs.h>
 #include <libcpu/coreTimerRegs.h>
 
+#warning Call to boot_card has changed and needs checking.
+#warning The call is "void boot_card(const char* cmdline);"
+#warning Please check and remove these warnings.
+
 #ifndef LO
 #define LO(con32) ((con32) & 0xFFFF)
 #endif
Index: c/src/lib/libbsp/bfin/shared/start/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/bfin/shared/start/start.S,v
retrieving revision 1.6
diff -p -u -u -r1.6 start.S
--- c/src/lib/libbsp/bfin/shared/start/start.S	25 Sep 2008 14:10:51 -0000	1.6
+++ c/src/lib/libbsp/bfin/shared/start/start.S	24 Apr 2009 07:09:15 -0000
@@ -4,6 +4,10 @@
 
 #include <bspopts.h>
 
+#warning Call to boot_card has changed and needs checking.
+#warning The call is "void boot_card(const char* cmdline);"
+#warning Please check and remove these warnings.
+
 #ifndef LO
 #define LO(con32) ((con32) & 0xFFFF)
 #endif
Index: c/src/lib/libbsp/c4x/c4xsim/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/c4x/c4xsim/ChangeLog,v
retrieving revision 1.98
diff -p -u -u -r1.98 ChangeLog
--- c/src/lib/libbsp/c4x/c4xsim/ChangeLog	4 Dec 2008 20:32:39 -0000	1.98
+++ c/src/lib/libbsp/c4x/c4xsim/ChangeLog	24 Apr 2009 07:09:15 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* start/start.S: Update for boot_card command line change.
+
 2008-12-04	Joel Sherrill <joel.sherrill@oarcorp.com>
 
 	* bsp_specs: Move -e start from *link to *startfile to avoid warning
Index: c/src/lib/libbsp/c4x/c4xsim/start/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/c4x/c4xsim/start/start.S,v
retrieving revision 1.2
diff -p -u -u -r1.2 start.S
--- c/src/lib/libbsp/c4x/c4xsim/start/start.S	21 Apr 2004 10:42:43 -0000	1.2
+++ c/src/lib/libbsp/c4x/c4xsim/start/start.S	24 Apr 2009 07:09:15 -0000
@@ -3,6 +3,11 @@
  *  provided by Herman ...XXX
  */
 
+#warning Call to boot_card has changed and needs checking.
+#warning The call is "void boot_card(const char* cmdline);"
+#warning You need to pass a NULL.
+#warning Please check and remove these warnings.
+
 	; .file	"crt0.s"
 	.ref	_c_int00
 	.global	start
@@ -65,7 +70,7 @@ _c_int00:
         ldi     @stack_addr,sp
         ldi     sp,ar3
         ldp     .bss		; For the small model, set up the DP to .bss
-	ldi	0,ar2		; make sure argc=0 with regparm
+	ldi	0,ar2		; make sure cmdline=0 with regparm
 	push	ar2		; and memparm
         call    _boot_card
         call	_sim_exit
Index: c/src/lib/libbsp/h8300/h8sim/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/h8300/h8sim/ChangeLog,v
retrieving revision 1.106
diff -p -u -u -r1.106 ChangeLog
--- c/src/lib/libbsp/h8300/h8sim/ChangeLog	4 Dec 2008 20:33:14 -0000	1.106
+++ c/src/lib/libbsp/h8300/h8sim/ChangeLog	24 Apr 2009 07:09:15 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* start/start.S: Update for boot_card command line change.
+
 2008-12-04	Joel Sherrill <joel.sherrill@oarcorp.com>
 
 	* bsp_specs: Move -e start from *link to *startfile to avoid warning
Index: c/src/lib/libbsp/h8300/h8sim/start/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/h8300/h8sim/start/start.S,v
retrieving revision 1.2
diff -p -u -u -r1.2 start.S
--- c/src/lib/libbsp/h8300/h8sim/start/start.S	21 Apr 2004 10:42:43 -0000	1.2
+++ c/src/lib/libbsp/h8300/h8sim/start/start.S	24 Apr 2009 07:09:15 -0000
@@ -1,5 +1,10 @@
 ; h8/300 and h8/300h start up file.
 
+#warning Call to boot_card has changed and needs checking.
+#warning The call is "void boot_card(const char* cmdline);"
+#warning You need to pass a NULL.
+#warning Please check and remove these warnings.
+	
 #ifdef __H8300__
 
 	.text
Index: c/src/lib/libbsp/i386/i386ex/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/i386/i386ex/ChangeLog,v
retrieving revision 1.129
diff -p -u -u -r1.129 ChangeLog
--- c/src/lib/libbsp/i386/i386ex/ChangeLog	10 Feb 2009 10:03:14 -0000	1.129
+++ c/src/lib/libbsp/i386/i386ex/ChangeLog	24 Apr 2009 07:09:15 -0000
@@ -1,3 +1,7 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* start/start.S: Update for boot_card command line change.
+
 2009-02-10	Ralf Corsépius <ralf.corsepius@rtems.org>
 
 	* clock/ckinit.c, startup/bspstart.c: Add prototypes.
Index: c/src/lib/libbsp/i386/i386ex/start/start.S
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/i386/i386ex/start/start.S,v
retrieving revision 1.11
diff -p -u -u -r1.11 start.S
--- c/src/lib/libbsp/i386/i386ex/start/start.S	21 Apr 2004 16:01:32 -0000	1.11
+++ c/src/lib/libbsp/i386/i386ex/start/start.S	24 Apr 2009 07:09:15 -0000
@@ -467,9 +467,7 @@ SYM (zero_bss):
 /*
  *  Transfer control to User's Board Support Package
  */
-        pushl   $0                       # environp
-        pushl   $0                       # argv
-        pushl   $0                       # argc
+        pushl   $0                       # command line
 
 	movw    $0xFFFB, SYM(i8259s_cache)	# ICU mask values reflect
 						# initial ICU state
Index: c/src/lib/libbsp/i386/pc386/ChangeLog
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/i386/pc386/ChangeLog,v
retrieving revision 1.214
diff -p -u -u -r1.214 ChangeLog
--- c/src/lib/libbsp/i386/pc386/ChangeLog	11 Feb 2009 19:48:24 -0000	1.214
+++ c/src/lib/libbsp/i386/pc386/ChangeLog	24 Apr 2009 07:09:15 -0000
@@ -1,3 +1,15 @@
+2009-04-23	Chris Johns <chrisj@rtems.org>
+
+	* Makefile.am: Add bspcmdline.c.
+	* include/bsp.h: Add boot command line interfaces.
+	* start/start.c: Save the multiboot command line. Pass the command
+	line to boot_card.
+	* start/start.S: Update for boot_card command line change.
+	* startup/bspstart.c: Initialise the command line.
+	* startup/bspcmdline.c: New.
+	* console/console.c, ide/idecfg.c: Add boot command line support.
+	* ide/ide.cfg: Add prints for errors to help resolve problems.
+
 2009-02-11	Joel Sherrill <joel.sherrill@oarcorp.com>
 
 	* configure.ac, start/start16.S: Remove duplicate configure option and
Index: c/src/lib/libbsp/i386/pc386/Makefile.am
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/i386/pc386/Makefile.am,v
retrieving revision 1.50
diff -p -u -u -r1.50 Makefile.am
--- c/src/lib/libbsp/i386/pc386/Makefile.am	2 Oct 2008 13:50:44 -0000	1.50
+++ c/src/lib/libbsp/i386/pc386/Makefile.am	24 Apr 2009 07:09:15 -0000
@@ -89,10 +89,10 @@ include_HEADERS += ../../i386/shared/com
 # startup
 libbsp_a_SOURCES += ../../shared/bsplibc.c ../../shared/bsppost.c \
     ../../shared/bsppredriverhook.c startup/bspgetworkarea.c \
-    ../../shared/bsppretaskinghook.c startup/bspstart.c \
+    ../../shared/bsppretaskinghook.c startup/bspstart.c startup/bspcmdline.c \
     ../../shared/bspclean.c startup/bspreset.c ../../i386/shared/irq/idt.c \
     ../../i386/shared/irq/irq.c ../../i386/shared/irq/irq_init.c \
-    ../../shared/bootcard.c ../../shared/sbrk.c \
+    ../../shared/bootcard.c ../../shared/bspinit.c ../../shared/sbrk.c \
     startup/ldsegs.S ../../i386/shared/irq/irq_asm.S
 
 # timer
Index: c/src/lib/libbsp/i386/pc386/console/console.c
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/i386/pc386/console/console.c,v
retrieving revision 1.40
diff -p -u -u -r1.40 console.c
--- c/src/lib/libbsp/i386/pc386/console/console.c	3 Nov 2008 20:57:38 -0000	1.40
+++ c/src/lib/libbsp/i386/pc386/console/console.c	24 Apr 2009 07:09:15 -0000
@@ -149,7 +149,34 @@ console_initialize(rtems_device_major_nu
                    void                      *arg)
 {
   rtems_status_code status;
+  const char* mode;
+  
+  /*
+   * Check the command line for the type of mode
+   * the consol is.
+   */
+  mode = bsp_cmdline_arg ("--console=");
 
+  if (mode)
+  {
+    mode += sizeof ("--console=") - 1;
+    if (strncmp (mode, "console", sizeof ("console") - 1) == 0)
+    {
+      BSPConsolePort = BSP_CONSOLE_PORT_CONSOLE;
+      BSPPrintkPort  = BSP_CONSOLE_PORT_CONSOLE;
+    }
+    else if (strncmp (mode, "com1", sizeof ("com1") - 1) == 0)
+    {
+      BSPConsolePort = BSP_UART_COM1;
+      BSPPrintkPort  = BSP_UART_COM1;
+    }
+    else if (strncmp (mode, "com2", sizeof ("com2") - 1) == 0)
+    {
+      BSPConsolePort = BSP_UART_COM2;
+      BSPPrintkPort  = BSP_UART_COM2;
+    }
+  }
+  
   /* Initialize the KBD interface */
   kbd_init();
 
Index: c/src/lib/libbsp/i386/pc386/ide/ide.c
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/i386/pc386/ide/ide.c,v
retrieving revision 1.10
diff -p -u -u -r1.10 ide.c
--- c/src/lib/libbsp/i386/pc386/ide/ide.c	6 Sep 2008 17:04:47 -0000	1.10
+++ c/src/lib/libbsp/i386/pc386/ide/ide.c	24 Apr 2009 07:09:15 -0000
@@ -30,6 +30,51 @@
 #include <libchip/ide_ctrl_io.h>
 
 /* #define DEBUG_OUT */
+
+static bool pc386_ide_status_busy (uint32_t port,
+                                   uint32_t timeout,
+                                   uint8_t* status_val)
+{
+  do
+  {
+    inport_byte (port + IDE_REGISTER_STATUS, *status_val);
+    if ((*status_val & IDE_REGISTER_STATUS_BSY) == 0)
+      return true;
+
+    if (timeout)
+    {
+      timeout--;
+      rtems_task_wake_after (TOD_MICROSECONDS_TO_TICKS (1000));
+    }
+  }
+  while (timeout);
+
+  return false;
+}
+
+static bool pc386_ide_status_data_ready (uint32_t port,
+                                         uint32_t timeout,
+                                         uint8_t* status_val)
+{
+  do
+  {
+    inport_byte (port + IDE_REGISTER_STATUS, *status_val);
+    
+    if (((*status_val & IDE_REGISTER_STATUS_BSY) == 0) &&
+        (*status_val & IDE_REGISTER_STATUS_DRQ))
+      return true;
+
+    if (timeout)
+    {
+      timeout--;
+      rtems_task_wake_after (TOD_MICROSECONDS_TO_TICKS (1000));
+    }
+  }
+  while (timeout);
+
+  return false;
+}
+
 /*
  * support functions for IDE harddisk IF
  */
@@ -174,18 +219,28 @@ void pc386_ide_read_block
   uint32_t    port = IDE_Controller_Table[minor].port1;
   uint16_t    cnt = 0;
   uint32_t    llength = bufs[(*cbuf)].length;
-  uint8_t   status_val;
+  uint8_t     status_val;
   uint16_t   *lbuf = (uint16_t*)
     ((uint8_t*)(bufs[(*cbuf)].buffer) + (*pos));
 
-  inport_byte(port+IDE_REGISTER_STATUS,status_val);
-  while ((status_val & IDE_REGISTER_STATUS_DRQ) &&
-	 (cnt < block_size)) {
+  while (cnt < block_size)
+  {
+    if (!pc386_ide_status_data_ready (port, 100, &status_val))
+    {
+      printk ("pc386_ide_read_block: status=%02x, cnt=%d bs=%d\n", status_val, cnt, block_size);
+      /* FIXME: add an error here. */
+      return;
+    }
+    
+    if (status_val & IDE_REGISTER_STATUS_ERR)
+      printk("pc386_ide_read_block: error: %02x\n", status_val);
+    
     inport_word(port+IDE_REGISTER_DATA,*lbuf);
 
 #ifdef DEBUG_OUT
     printk("0x%x ",*lbuf);
 #endif
+
     lbuf++;
     cnt    += sizeof(*lbuf);
     (*pos) += sizeof(*lbuf);
@@ -195,11 +250,7 @@ void pc386_ide_read_block
       lbuf = bufs[(*cbuf)].buffer;
       llength = bufs[(*cbuf)].length;
     }
-    inport_byte(port+IDE_REGISTER_STATUS,status_val);
   }
-#ifdef DEBUG_OUT
-  printk("pc386_ide_read_block()\r\n");
-#endif
 }
 
 /*=========================================================================*\
@@ -230,13 +281,23 @@ void pc386_ide_write_block
   uint8_t     status_val;
   uint16_t   *lbuf = (uint16_t*)
     ((uint8_t*)(bufs[(*cbuf)].buffer) + (*pos));
-
+  
 #ifdef DEBUG_OUT
-  printk("pc386_ide_write_block()\r\n");
+  printk("pc386_ide_write_block()\n");
 #endif
-  inport_byte(port+IDE_REGISTER_STATUS,status_val);
-  while ((status_val & IDE_REGISTER_STATUS_DRQ) &&
-	 (cnt < block_size)) {
+
+  while (cnt < block_size)
+  {
+    if (!pc386_ide_status_data_ready (port, 100, &status_val))
+    {
+      printk ("pc386_ide_write_block: status=%02x, cnt=%d bs=%d\n", status_val, cnt, block_size);
+      /* FIXME: add an error here. */
+      return;
+    }
+    
+    if (status_val & IDE_REGISTER_STATUS_ERR)
+      printk("pc386_ide_write_block: error: %02x\n", status_val);
+    
 #ifdef DEBUG_OUT
     printk("0x%x ",*lbuf);
 #endif
@@ -250,7 +311,6 @@ void pc386_ide_write_block
       lbuf = bufs[(*cbuf)].buffer;
       llength = bufs[(*cbuf)].length;
     }
-    inport_byte(port+IDE_REGISTER_STATUS,status_val);
   }
 }
 
Index: c/src/lib/libbsp/i386/pc386/ide/idecfg.c
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/i386/pc386/ide/idecfg.c,v
retrieving revision 1.6
diff -p -u -u -r1.6 idecfg.c
--- c/src/lib/libbsp/i386/pc386/ide/idecfg.c	29 Sep 2005 08:05:32 -0000	1.6
+++ c/src/lib/libbsp/i386/pc386/ide/idecfg.c	24 Apr 2009 07:09:15 -0000
@@ -35,7 +35,6 @@ extern ide_ctrl_fns_t pc386_ide_ctrl_fns
 
 /* IDE controllers Table */
 ide_controller_bsp_table_t IDE_Controller_Table[] = {
-#if IDE_USE_PRIMARY_INTERFACE
   {"/dev/ide0",
    IDE_STD, /* standard IDE controller */
    &pc386_ide_ctrl_fns,
@@ -45,11 +44,7 @@ ide_controller_bsp_table_t IDE_Controlle
    FALSE,0, /* not (yet) interrupt driven */
    NULL
   }
-#if IDE_USE_SECONDARY_INTERFACE
   , /* colon only needed when both interfaces present */
-#endif
-#endif
-#if IDE_USE_SECONDARY_INTERFACE
   {"/dev/ide1",
    IDE_STD, /* standard IDE controller */
    &pc386_ide_ctrl_fns,
@@ -59,9 +54,74 @@ ide_controller_bsp_table_t IDE_Controlle
    FALSE,0, /* not (yet) interrupt driven */
    NULL
   }
-#endif
 };
 
-/* Number of rows in IDE_Controller_Table */
-unsigned long IDE_Controller_Count =
-   sizeof(IDE_Controller_Table)/sizeof(IDE_Controller_Table[0]);
+/* Number of rows in IDE_Controller_Table. Default is 0. */
+unsigned long IDE_Controller_Count;
+
+#if IDE_USE_PRIMARY_INTERFACE
+#define IDE1_DEFAULT true
+#else
+#define IDE1_DEFAULT false
+#endif
+#if IDE_USE_SECONDARY_INTERFACE
+#define IDE2_DEFAULT true
+#else
+#define IDE2_DEFAULT false
+#endif
+
+void bsp_ide_cmdline_init(void)
+{
+  bool ide1 = IDE1_DEFAULT;
+  bool ide2 = IDE2_DEFAULT;
+  const char* ide;
+  
+  /*
+   * Can have:
+   *  --ide=1,2
+   */
+  ide = bsp_cmdline_arg ("--ide=");
+  
+  if (ide)
+  {
+    int i;
+    /*
+     * If a command line option exists remove the defaults.
+     */
+    ide1 = ide2 = false;
+    
+    ide += sizeof ("--ide=") - 1;
+    
+    for (i = 0; i < 3; i++)
+    {
+      switch (ide[i])
+      {
+        case '1':
+          ide1 = true;
+          break;
+        case '2':
+          ide2 = true;
+          break;
+        case '3':
+        case '4':
+        case '5':
+        case '6':
+        case '7':
+        case '8':
+        case '9':
+        case ',':
+          break;
+        default:
+        break;
+      }
+    }
+  }
+
+  if (ide2 && !ide1)
+    IDE_Controller_Table[0] = IDE_Controller_Table[1];
+
+  if (ide1)
+    IDE_Controller_Count++;
+  if (ide2)
+    IDE_Controller_Count++;
+}
Index: c/src/lib/libbsp/i386/pc386/include/bsp.h
===================================================================
RCS file: /usr1/CVS/rtems/c/src/lib/libbsp/i386/pc386/include/bsp.h,v
retrieving revision 1.40
diff -p -u -u -r1.40 bsp.h
--- c/src/lib/libbsp/i386/pc386/include/bsp.h	22 Sep 2008 21:49:43 -0000	1.40
+++ c/src/lib/libbsp/i386/pc386/include/bsp.h	24 Apr 2009 07:09:15 -0000
@@ -183,6 +183,17 @@ void Wait_X_ms(unsigned int timeToWait);
 #define BSP_CONSOLE_PORT_COM2    (BSP_UART_COM2)
 
 /*
+ * Command line.
+ */
+const char* bsp_cmdline(void);
+const char* bsp_cmdline_arg(const char* arg);
+
+/*
+ * IDE command line parsing.
+ */
+void bsp_ide_cmdline_init(void);
+
+/*
  * indicate, that BSP has IDE driver
  */
 #define RTEMS_BSP_HAS_IDE_DRIVER
